Subject: bug#14704: 24.3.50; cl-lib breaks built-in Emacs version

From: Sebastian Wiesner <[email-masked]>
Date: Mon, 24 Jun 2013 20:57:04 +0200

2013/6/24 Eli Zaretskii <[email-masked]>:
>> Date: Mon, 24 Jun 2013 20:26:27 +0200
>> From: Sebastian Wiesner <[email-masked]>
>> Cc: [email-masked]
>>
>> I did neither scream nor demand, but I actually expected you to apply
>> care and attention to your work.  I write tests for my own code, and I
>> run them, and I expected you to do so as well.  I see now, that you do
>> not, which is embarrassing to you and very ignorant towards your
>> users.
>
> Out of fairness, you found 3 bugs in a single 1700-line package, and
> made very far-fetching conclusions ("Don't you test your code?!") out
> of that.

These three bugs weren't just stupid forgotten corner cases in some
remote and obscure feature that none uses.  They broke an essential
command—which worked well before—in a very obvious and very bad way.

These bugs should have been caught by testing before making a commit.
But they weren't, so in this specific case, I think I can quite
legitimately conclude that these specific changes were not tested at
all, or only very carelessly.

I understand that package.el is being refactored currently, but that
isn't an excuse imho.  On the contrary, every software development
course teaches about making refactorings in a separate branch and
never without unit tests.

But I admit that I should not have generalized this statement, and I
apologize to you and to everyone else whom I offended.

> If all that code were not tested at all, it would never have worked at all.

It is tested, for sure, but probably less by you, and more by your users.